Jmol
Date: 2019-10-22

org.jmol.applet

## Class Jmol

- java.lang.Object
- - org.jmol.util.GenericApplet
  - - org.jmol.applet.Jmol

- All Implemented Interfaces:
    JmolAppletInterface, JmolCallbackListener, JmolStatusListener, JmolSyncInterface, WrappedApplet

      public class Jmol
      extends GenericApplet
      implements WrappedApplet

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private java.lang.Boolean` | `allowJSEval`
    `private java.applet.Applet` | `applet`
    `private FileDropper` | `dropper`
    `private boolean` | `isUpdating`
    `private netscape.javascript.JSObject` | `jsoDocument`
    `private int` | `lastMotionEventNumber`
    `private boolean` | `showPaintTime`
    `private long` | `timeBegin`
    `private int` | `timeCount`
    `private int` | `timeLast`
    `private int` | `timeTotal`

    - ### Fields inherited from class org.jmol.util.GenericApplet

      `appletObject, callbacks, codeBase, documentBase, doTranslate, fullName, gRight, haveDocumentAccess, haveNotifiedError, htmlName, htRegistry, isJNLP, isJS, isSigned, isStereoSlave, language, mayScript, statusForm, statusText, statusTextarea, viewer, vwrOptions`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Jmol()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `private void` | `addValue(java.util.Map<java.lang.String,java.lang.Object> info, java.lang.String key, java.lang.String putKey, java.lang.Object value)`
    `private static void` | `cleanRegistry()`
    `void` | `destroy()`
    `protected java.lang.String` | `doEval(java.lang.String strEval)`
    `float[][]` | `doFunctionXY(java.lang.String functionName, int nX, int nY)`
    `float[][][]` | `doFunctionXYZ(java.lang.String functionName, int nX, int nY, int nZ)`
    `protected java.lang.String` | `doSendCallback(java.lang.String callback, java.lang.Object[] data, java.lang.String strInfo)`
    `protected void` | `doSendJsTextareaStatus(java.lang.String message)`
    `protected void` | `doSendJsTextStatus(java.lang.String message)`
    `protected void` | `doShowDocument(java.net.URL url)`
    `protected void` | `doShowStatus(java.lang.String message)`
    `private java.lang.String` | `fmt(int num)`
    `protected java.lang.String` | `getJmolParameter(java.lang.String paramName)`
    `private void` | `getJsObjectInfo(java.lang.Object[] data)` probably never used -- only by Java applet reading directly from the DOM in an XHTML document.
    `protected void` | `initOptions()`
    `void` | `paint(java.awt.Graphics g)`
    `int[]` | `resizeInnerPanel(java.lang.String data)`
    `void` | `setApplet(java.applet.Applet a, boolean isSigned)`
    `java.lang.Object` | `setStereoGraphics(boolean isStereo)`
    `private void` | `showTimes(int x, int y, java.awt.Graphics g)`
    `private void` | `startPaintClock()`
    `private void` | `stopPaintClock()`
    `void` | `update(java.awt.Graphics g)`
    `private void` | `update(java.awt.Graphics g, java.lang.String source)`

    - ### Methods inherited from class org.jmol.util.GenericApplet

      `createImage, eval, functionXY, functionXYZ, getAppletInfo, getBooleanValue, getJSpecViewProperty, getModelIndexFromId, getProperty, getProperty, getPropertyAsJSON, getPropertyAsJSON, getPropertyAsString, getPropertyAsString, getRegistryInfo, getValue, handleEvent, init, loadDOMNode, loadInline, loadInline, loadInline, loadInline, loadInlineArray, loadInlineString, notifyAudioEnded, notifyCallback, notifyEnabled, output, register, script, scriptCheck, scriptNoWait, scriptWait, scriptWait, scriptWaitOutput, setCallbackFunction, showUrl, syncScript`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### isUpdating

          private boolean isUpdating

    - #### showPaintTime

          private boolean showPaintTime

    - #### timeLast

          private int timeLast

    - #### timeCount

          private int timeCount

    - #### timeTotal

          private int timeTotal

    - #### lastMotionEventNumber

          private int lastMotionEventNumber

    - #### timeBegin

          private long timeBegin

    - #### dropper

          private FileDropper dropper

    - #### applet

          private java.applet.Applet applet

    - #### allowJSEval

          private java.lang.Boolean allowJSEval

    - #### jsoDocument

          private netscape.javascript.JSObject jsoDocument

  - ### Constructor Detail

    - #### Jmol

          public Jmol()

  - ### Method Detail

    - #### setApplet

          public void setApplet(java.applet.Applet a,
                                boolean isSigned)

      Specified by:
        `setApplet` in interface `WrappedApplet`

    - #### paint

          public void paint(java.awt.Graphics g)

      Specified by:
        `paint` in interface `WrappedApplet`

    - #### update

          public void update(java.awt.Graphics g)

      Specified by:
        `update` in interface `WrappedApplet`

    - #### destroy

          public void destroy()

      Specified by:
        `destroy` in interface `JmolAppletInterface`
      Overrides:
        `destroy` in class `GenericApplet`

    - #### setStereoGraphics

          public java.lang.Object setStereoGraphics(boolean isStereo)

      Specified by:
        `setStereoGraphics` in interface `JmolAppletInterface`

    - #### initOptions

          protected void initOptions()

      Specified by:
        `initOptions` in class `GenericApplet`

    - #### addValue

          private void addValue(java.util.Map<java.lang.String,java.lang.Object> info,
                                java.lang.String key,
                                java.lang.String putKey,
                                java.lang.Object value)

    - #### cleanRegistry

          private static void cleanRegistry()

    - #### getJmolParameter

          protected java.lang.String getJmolParameter(java.lang.String paramName)

      Specified by:
        `getJmolParameter` in class `GenericApplet`

    - #### doSendJsTextStatus

          protected void doSendJsTextStatus(java.lang.String message)

      Specified by:
        `doSendJsTextStatus` in class `GenericApplet`

    - #### doSendJsTextareaStatus

          protected void doSendJsTextareaStatus(java.lang.String message)

      Specified by:
        `doSendJsTextareaStatus` in class `GenericApplet`

    - #### update

          private void update(java.awt.Graphics g,
                              java.lang.String source)

      Parameters:
        `g` -
        `source` - for debugging only

    - #### startPaintClock

          private void startPaintClock()

    - #### stopPaintClock

          private void stopPaintClock()

    - #### fmt

          private java.lang.String fmt(int num)

    - #### showTimes

          private void showTimes(int x,
                                 int y,
                                 java.awt.Graphics g)

    - #### resizeInnerPanel

          public int[] resizeInnerPanel(java.lang.String data)

      Specified by:
        `resizeInnerPanel` in interface `JmolStatusListener`
      Overrides:
        `resizeInnerPanel` in class `GenericApplet`

    - #### doSendCallback

          protected java.lang.String doSendCallback(java.lang.String callback,
                                                    java.lang.Object[] data,
                                                    java.lang.String strInfo)

      Specified by:
        `doSendCallback` in class `GenericApplet`

    - #### getJsObjectInfo

          private void getJsObjectInfo(java.lang.Object[] data)

      probably never used -- only by Java applet reading directly from the DOM in an XHTML document.
      Parameters:
        `data` -

    - #### doEval

          protected java.lang.String doEval(java.lang.String strEval)

      Specified by:
        `doEval` in class `GenericApplet`

    - #### doFunctionXY

          public float[][] doFunctionXY(java.lang.String functionName,
                                        int nX,
                                        int nY)

      Specified by:
        `doFunctionXY` in class `GenericApplet`

    - #### doFunctionXYZ

          public float[][][] doFunctionXYZ(java.lang.String functionName,
                                           int nX,
                                           int nY,
                                           int nZ)

      Specified by:
        `doFunctionXYZ` in class `GenericApplet`

    - #### doShowDocument

          protected void doShowDocument(java.net.URL url)

      Specified by:
        `doShowDocument` in class `GenericApplet`

    - #### doShowStatus

          protected void doShowStatus(java.lang.String message)

      Specified by:
        `doShowStatus` in class `GenericApplet`